
SELECT

DISTINCT incident.rowid _id
    , title
    , incidentid
    , inno_path
    , inno_statusname
    , createdon
    , followupby
    , DATETIME(incident.followupby, '-'|| (inno_duration * ?) ||' minutes') AS NextWarningTime

FROM incident
INNER JOIN inno_location ON inno_location.inno_locationid = incident.inno_location

INNER JOIN (SELECT inno_internalpath || '%' AS ROOT_inno_internalpath
FROM inno_location
INNER JOIN inno_userlocation ON inno_locationid = inno_userlocation_locationid
WHERE inno_userlocation.inno_userlocation_userid = ? -- UserId
AND inno_userlocation.statecode = ? -- Active == 0
) AS ROOTS ON inno_location.inno_internalpath LIKE ROOT_inno_internalpath

LEFT JOIN inno_status ON inno_status.inno_statusid = incident.inno_statusid
LEFT JOIN team ON team.teamid = incident.inno_incident_assignedteamid
LEFT JOIN teammembership ON team.teamid = teammembership.teamid
LEFT JOIN inno_servicelevel ON inno_servicelevelid = incident.inno_servicelevel

WHERE

    (inno_status.LocalId IS NULL OR (
    	inno_status.inno_statusallowedonmobile <> 0 AND
    		--//v17 A.G 10834 Show Tasks with Rejected Status in the list. Removed 3rd ?
    	inno_status.inno_mappedstatusname NOT IN (?, ?, ?) --(341380010, 341380011, 341380004)  -- (inno_status_inno_mappedstatusname_enum ProblemSolved, Canceled, Rejected)
    	)
	)
AND (incident.inno_assignedto = ? -- UserId
    OR
        ((incident.inno_assignedto = ? -- Guid.Empty
         OR incident.inno_assignedto IS NULL)
        AND team.inno_teamtype IN  (?, ?) -- (341380002, 341380003) ServicetracHelpdesk, ServicetracAuditHelpdesk
        AND teammembership.systemuserid = ? -- UserId
        )
    )
AND (incident.prioritycode = ? OR NextWarningTime < datetime(?) OR NextWarningTime BETWEEN datetime(?) AND datetime(?))
AND CASE
    -- Is Overdue inno_duration
    WHEN incident.followupby < datetime(?) THEN 'o'
    -- Is Due
    WHEN inno_duration IS NULL OR datetime(?) > DATETIME(incident.followupby, '-'|| (inno_duration * ?) ||' minutes')
   -- OR incident.followupby < datetime(?)
    THEN 'd'
    -- Is not due
    ELSE 'n'
    END IN (?, ?, ?)
AND incident.inno_incident_assignedteamid LIKE '%' || ? || '%' -- Selected Team
AND (incident.title LIKE '%' || ? || '%'
OR inno_path LIKE '%' || ? || '%'
OR ticketnumber LIKE '%' || ? || '%'
OR REPLACE(inno_location.inno_siteaddresspostcode, ' ', '') LIKE '%' || ? || '%')