SELECT DISTINCT [kr].[inno_hooknumber],
                [kr].[inno_imageurl],
                [kr].[inno_keycaseid],
                [kr].[inno_keyringid],
                [kr].[inno_lastauditdate],
                [kr].[inno_name],
                [kr].[inno_sealbroken],
                [kr].[inno_sealid],
                [kr].[inno_sealidprevious],
                [kr].[statecode],
                [kr].[Localid],
                [kr].[inno_lastcomment],
                [kc].[inno_name] AS [KeyCaseName],
                [k].[cnt]        AS [NumberOfKeys],
                [u].inno_comment AS [SkipReason]
FROM   [inno_keyring] [kr]
       INNER JOIN [inno_keyringlocation] [kl]
               ON [kr].[inno_keyringid] = [kl].[inno_keyringid]
       INNER JOIN [inno_location] [l]
               ON [l].[localid] = [kl].[inno_locationid]
       INNER JOIN [inno_keycase] [kc]
               ON [kc].[inno_keycaseid] = [kr].[inno_keycaseid]
      INNER JOIN (SELECT inno_internalpath
                                  || '%' AS ROOT_inno_internalpath
                           FROM   inno_location
                                  INNER JOIN inno_userlocation
                                          ON inno_locationid =
                                             inno_userlocation_locationid
                           WHERE  inno_userlocation.inno_userlocation_userid = ?
                                  AND inno_userlocation.statecode = 0) AS ROOTS
               ON [l].inno_internalpath LIKE root_inno_internalpath
       LEFT JOIN (SELECT [u].inno_keyringid,
                                [u].[inno_comment]
                  FROM   [inno_keyringusage] [u]
                  WHERE  [u].[statecode] = 0
                  AND [u].inno_comment IS NOT NULL
                  GROUP  BY [u].[inno_keyringid]
                  ORDER  BY [u].overriddencreatedon DESC) AS [u]
               ON [u].inno_keyringid = kr.localid
       LEFT JOIN (SELECT [k].[inno_keyringid],
                         Count (1) [Cnt]
                  FROM   [inno_key] [k]
                  WHERE  [k].[statecode] = 0
                  GROUP  BY [k].[inno_keyringid]) AS k
              ON [k].[inno_keyringid] = [kr].[localid]
WHERE  [kr].[statecode] = 0
       AND [kc].[statecode] = 0
       /*INTERNAL PATHS*/
UNION
SELECT 0                                      AS [inno_hooknumber],
       NULL                                   AS [inno_imageurl],
       '00000000-0000-0000-0000-000000000000' AS [inno_keycaseid],
       '00000000-0000-0000-0000-000000000000' AS [inno_keyringid],
       Datetime('now')                        AS [inno_lastauditdate],
       'No Keyrings Required'                 AS [inno_name],
       0                                      AS [inno_sealbroken],
       ''                                     AS [inno_sealid],
       ''                                     AS [inno_sealidprevious],
       0                                      AS [statecode],
       '00000000-0000-0000-0000-000000000000' AS [Localid],
       ''                                     AS [inno_lastcomment],
       ''                                     AS [KeyCaseName],
       0                                      AS [NumberOfKeys],
       ''                                     AS [SkipReason]

ORDER  BY [inno_keycaseid] ASC,[inno_hooknumber] ASC