-- Service Appointments HP COUNT -- query_count_serviceappointments_hp.sql = Get count of HIGH priority Service Appointments for this user
SELECT

	COUNT(DISTINCT(serviceappointment.LocalId))
	
	
	
FROM serviceappointment
INNER JOIN inno_location ON inno_location.inno_locationid = serviceappointment.inno_location

INNER JOIN (SELECT inno_internalpath || '%' AS ROOT_inno_internalpath
FROM inno_location
INNER JOIN inno_userlocation ON inno_locationid = inno_userlocation_locationid
WHERE inno_userlocation.inno_userlocation_userid = ? /* UserId */
AND inno_userlocation.statecode = ? /* Active == 0 */
) AS ROOTS ON inno_location.inno_internalpath LIKE ROOT_inno_internalpath

LEFT JOIN inno_status ON inno_status.inno_statusid = serviceappointment.inno_statusid
LEFT JOIN team ON team.teamid = serviceappointment.ownerid 
LEFT JOIN teammembership ON team.teamid = teammembership.teamid 


WHERE

    (inno_status.LocalId IS NULL OR (
    	inno_status.inno_statusallowedonmobile <> 0
    	AND inno_status.inno_mappedstatusname NOT IN (?, ?, ?) --(341380010, 341380011)  -- (inno_status_inno_mappedstatusname_enum.ProblemSolved, inno_status_inno_mappedstatusname_enum.Canceled)
    	)
	)
AND (serviceappointment.resources LIKE '%' || ? || '%' /* UserId */
    OR serviceappointment.inno_assignedto = ? /* UserId */
    OR
        ((serviceappointment.inno_assignedto = ? /* Guid.Empty */ OR serviceappointment.inno_assignedto IS NULL)
        AND (serviceappointment.resources LIKE '%' || ? || '%' /* Guid.Empty */ OR serviceappointment.resources = '' OR serviceappointment.resources LIKE '%"entities":[]%' OR serviceappointment.resources IS NULL)
        AND team.inno_teamtype IN  (?, ?) /* (341380002, 341380003) ServicetracHelpdesk, ServicetracAuditHelpdesk */
        AND teammembership.systemuserid = ? /* UserId */
        )
    )
AND serviceappointment.scheduledstart BETWEEN ? AND ?
AND serviceappointment.prioritycode = ? /* 2 High */