-- Service Appointments -- query_todo_lv_serviceappointment.sql = All SAs for user and their teams
SELECT

--COUNT COUNT(DISTINCT(serviceappointment.activityid))
/*SELECT-START
DISTINCT serviceappointment.rowid _id
    , scheduledend
    , subject
    , inno_serviceactivityid
    , prioritycode
    , activityid
    , inno_path
    , inno_statusname
    , inno_statusallowedonmobile
    , scheduledstart
    , team.name
SELECT-END*/

FROM serviceappointment
INNER JOIN inno_location ON inno_location.inno_locationid = serviceappointment.inno_location

INNER JOIN (SELECT inno_internalpath || '%' AS ROOT_inno_internalpath
FROM inno_location
INNER JOIN inno_userlocation ON inno_locationid = inno_userlocation_locationid
WHERE inno_userlocation.inno_userlocation_userid = ? -- UserId
AND inno_userlocation.statecode = ? -- Active == 0
) AS ROOTS ON inno_location.inno_internalpath LIKE ROOT_inno_internalpath

LEFT JOIN inno_status ON inno_status.inno_statusid = serviceappointment.inno_statusid
LEFT JOIN team ON team.teamid = serviceappointment.ownerid
LEFT JOIN teammembership ON team.teamid = teammembership.teamid


WHERE

    (inno_status.LocalId IS NULL OR (
    	  inno_status.inno_statusallowedonmobile <> 0 AND
    		--//v17 A.G 10834 Show Tasks with Rejected Status in the list. Removed 3rd ?
    	 inno_status.inno_mappedstatusname NOT IN (?, ?, ?) --(341380010, 341380011, 341380004)  -- (inno_status_inno_mappedstatusname_enum ProblemSolved, Canceled, Rejected)
    	)
	)
AND (serviceappointment.resources LIKE '%' || ? || '%' -- UserId
    OR serviceappointment.inno_assignedto = ? -- UserId
    OR
        ((serviceappointment.inno_assignedto = ? /* Guid.Empty */ OR serviceappointment.inno_assignedto IS NULL)
        AND (serviceappointment.resources LIKE '%' || ? || '%' /* Guid.Empty */ OR serviceappointment.resources = '' OR serviceappointment.resources LIKE '%"entities":[]%' OR serviceappointment.resources IS NULL)
        AND team.inno_teamtype IN  (?, ?) /* (341380002, 341380003) ServicetracHelpdesk, ServicetracAuditHelpdesk */
        AND teammembership.systemuserid = ? -- UserId
        )
    )
AND (serviceappointment.prioritycode = ? OR serviceappointment.scheduledstart < datetime(?) OR serviceappointment.scheduledstart BETWEEN datetime(?) AND datetime(?))
AND CASE
    -- Is Overdue
    WHEN serviceappointment.scheduledend < datetime(?) THEN 'o'
    -- Is Due
        WHEN datetime(?) > serviceappointment.scheduledstart
     --   OR serviceappointment.scheduledstart < datetime(?)
        THEN 'd'
    -- Is not due
    ELSE 'n'
    END IN (?, ?, ?)
--AND serviceappointment.prioritycode = ? -- 2 High
--AND serviceappointment.ownerid = ? -- Selected Team
--AND inno_locationid IN (?, ...) -- Selected Site(s)