-- Audit Location Schedules - query_todo_lv_audit_schedules.sql -- all ALSs for specified location

/*SELECT-START
SELECT DISTINCT OriginalQuery.*,
MAX(NonTiedQsr.overriddencreatedon) as NonTiedQsrCreatedOn,
NonTiedQsr.localid as NonTiedQsrId,
NonTiedQsr.inno_maximumscore as NonTiedQsrMaxScore,
NonTiedQsr.inno_percentage as NonTiedQsrPercentage,
AccessDeniedQsr.inno_targetauditlocationscheduleid,
DraftQsr.istemp as hasTemp

FROM (
SELECT-END*/

SELECT

--COUNT COUNT(DISTINCT(inno_auditlocationschedule.inno_auditlocationscheduleid)),
--COUNT COUNT(DISTINCT(DraftQsr.istemp))

/*SELECT-START
DISTINCT
inno_auditlocationschedule.rowid _id
,inno_questionset.inno_name AS "inno_questionset_inno_name"
,inno_auditlocationschedule.inno_auditlocationscheduleid
,inno_auditlocationschedule.inno_name
,inno_auditlocationschedule.inno_nextauditdate
,inno_auditlocationschedule.inno_lastauditdate
,inno_auditlocationschedule.inno_auditfrequency
,inno_auditlocationschedule.inno_sampleauditperiodid
,inno_location.inno_path
,inno_location.inno_servicelevel
,inno_location.inno_parent
,samp.inno_startdate
,CASE
     -- Is Overdue
     WHEN inno_nextauditdate < datetime(?) AND inno_nextauditdate > '1971-01-01' THEN ?
     -- Is Due
     WHEN datetime(?) > CASE
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
         WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
         ----
          WHEN samp.inno_startdate NOT NULL AND samp.inno_startdate < CURRENT_TIMESTAMP THEN 20
         ----
         ELSE datetime(?)
         END THEN ?
     -- Is not due
     ELSE ?
     END AS Due
, COUNT(inno_questionsetresult.inno_questionsetresultid) AS "Count_Of_Questionsetresults"

-- AG: Add Warning Date Alias Column on the fly to Query Against (instead of inno_nextauditdate)
, CASE
           WHEN inno_repeatpatternstyle = '341380005' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
           WHEN inno_repeatpatternstyle = '341380006' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
           WHEN inno_repeatpatternstyle = '341380007' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
           WHEN inno_repeatpatternstyle = '341380008' THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
           WHEN inno_repeatpatternstyle = '341380009' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
           WHEN inno_repeatpatternstyle = '3413800010' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
           ELSE inno_nextauditdate
           END AS WarningDate,
--

-- CB add Team and Location ID to output
inno_auditlocationschedule.ownerid as teamId,
inno_auditlocationschedule_locationid as locationId
--
SELECT-END*/

FROM inno_auditlocationschedule
INNER JOIN inno_questionset ON inno_questionset.inno_questionsetid = inno_locationschedule_questionsetid
INNER JOIN team ON team.teamid = inno_auditlocationschedule.ownerid
INNER JOIN teammembership ON team.teamid = teammembership.teamid
INNER JOIN inno_location ON inno_location.inno_locationid = inno_auditlocationschedule_locationid
LEFT JOIN inno_repeatpattern ON inno_repeatpattern.inno_repeatpatternid = inno_auditlocationschedule.inno_warningrepeatpatternid
--
LEFT JOIN inno_sampleauditperiod samp ON inno_auditlocationschedule.inno_sampleauditperiodid = samp.localid
--
LEFT JOIN inno_questionsetresult ON inno_questionsetresult.inno_auditlocationschedule = inno_auditlocationschedule.inno_auditlocationscheduleid
	AND inno_questionsetresult.inno_questionsetresult_auditsessionid = ? AND inno_questionsetresult.istemp = 0

LEFT JOIN inno_questionsetresult DraftQsr ON inno_auditlocationschedule.inno_auditlocationscheduleid = DraftQsr.inno_auditlocationschedule
    AND DraftQsr.inno_questionsetresult_auditsessionid LIKE ?
    AND DraftQsr.statecode = 0
    AND DraftQsr.istemp = 1

WHERE team.inno_teamtype IN (?, ?)
AND teammembership.systemuserid = ?

AND ((inno_nextauditdate < datetime(?)

OR ((samp.inno_sampleauditperiodid != '00000000-0000-0000-0000-000000000000' AND
samp.inno_sampleauditperiodid NOT NULL)
OR inno_nextauditdate BETWEEN datetime(?) AND datetime(?))

OR ((samp.inno_sampleauditperiodid != '00000000-0000-0000-0000-000000000000' AND
samp.inno_sampleauditperiodid NOT NULL)
OR WarningDate < datetime(?) OR WarningDate BETWEEN datetime(?) AND datetime(?))

AND inno_nextauditdate > '1969-01-01') OR inno_nextauditdate IS NULL)
AND inno_auditlocationschedule.statecode = ? -- ACTIVE == 0
AND CASE
    -- Is Overdue
    WHEN inno_nextauditdate < datetime(?) AND inno_nextauditdate > '1971-01-01' THEN 'o'
    -- Is Due
    WHEN datetime(?) > CASE
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
        --
        WHEN samp.inno_startdate NOT NULL AND samp.inno_startdate < CURRENT_TIMESTAMP THEN 20
        --
        ELSE datetime(?)
        END THEN 'd'
    -- Is not due
    ELSE 'n'
    END IN (?, ?, ?)

--IGNORE SAMPLE AUDITS AND (inno_auditlocationschedule.inno_sampleauditperiodid = '00000000-0000-0000-0000-000000000000' OR inno_auditlocationschedule.inno_sampleauditperiodid = NULL)

AND inno_auditlocationschedule.inno_sampleauditperiodid NOT IN
(SELECT DISTINCT [qsetresult].[inno_sampleauditperiodid]
FROM   [inno_sampleauditperiod] [completesamps]
       INNER JOIN [inno_auditlocationschedule] [auditschedules] ON [completesamps].[inno_sampleauditperiodid] = [auditschedules].[inno_sampleauditperiodid]
       INNER JOIN [inno_questionsetresult] [qsetresult] ON [qsetresult].[inno_auditlocationschedule] = [auditschedules].[localid]
       INNER JOIN [inno_auditsession] [session] ON [session].[localid] = [qsetresult].[inno_questionsetresult_auditsessionid]
WHERE  [completesamps].[inno_sampleauditbehaviour] = '341380001'
         AND [session].[inno_status] = '341380002'
         AND [qsetresult].[inno_sampleauditperiodid] not null
         AND [qsetresult].[inno_sampleauditperiodid] != '00000000-0000-0000-0000-000000000000')


[XX-TEAM-XX] --AND inno_auditlocationschedule.ownerid = ? -- Selected Team
[XX-LOCATION-XX] --AND inno_auditlocationschedule_locationid = ?
[XX-ROOTLOCATION-XX] --inno_internalpath IN (? || '%', ? || '%', ...)

/*SELECT-START
GROUP BY
inno_auditlocationschedule.rowid
,inno_questionset.inno_name
,inno_auditlocationschedule.inno_auditlocationscheduleid
,inno_auditlocationschedule.inno_name
,inno_auditlocationschedule.inno_nextauditdate
,inno_auditlocationschedule.inno_lastauditdate
,inno_auditlocationschedule.inno_auditfrequency
,inno_auditlocationschedule.inno_sampleauditperiodid
,inno_location.inno_path
,inno_location.inno_servicelevel
,inno_location.inno_parent

ORDER BY inno_nextauditdate ASC
SELECT-END*/

/*SELECT-START
) OriginalQuery

LEFT JOIN inno_questionsetresult NonTiedQsr ON originalQuery.inno_auditlocationscheduleid = NonTiedQsr.inno_auditlocationschedule
AND NonTiedQsr.inno_questionsetresult_auditsessionid NOT LIKE ?
AND NonTiedQsr.istemp = 0

LEFT JOIN inno_questionsetresult AccessDeniedQsr ON originalQuery.inno_auditlocationscheduleid = AccessDeniedQsr.inno_targetauditlocationscheduleid
AND AccessDeniedQsr.inno_questionsetresult_auditsessionid LIKE ?
AND AccessDeniedQsr.istemp = 0

LEFT JOIN inno_questionsetresult DraftQsr ON originalQuery.inno_auditlocationscheduleid = DraftQsr.inno_auditlocationschedule
AND DraftQsr.inno_questionsetresult_auditsessionid LIKE ?
AND DraftQsr.statecode = 0
AND DraftQsr.istemp = 1

GROUP BY
originalQuery.rowid
,originalQuery.inno_name
,originalQuery.inno_auditlocationscheduleid
,originalQuery.inno_name
,originalQuery.inno_nextauditdate
,originalQuery.inno_lastauditdate
,originalQuery.inno_auditfrequency
,originalQuery.inno_sampleauditperiodid
,originalQuery.inno_path
,originalQuery.inno_servicelevel
,originalQuery.inno_parent

ORDER BY originalQuery.inno_nextauditdate ASC
SELECT-END*/