SELECT 
	systemuser.fullname
	, systemuser.inno_mobilepassword
	, systemuser.systemuserid systemuserid
	, systemuser.rowid _id
	, COUNT(CASE WHEN perm_role.name IN (?, ?) THEN 1 ELSE NULL END) IsAuditAllowed --('System Administrator', 'Mobile Audit User')
	, COUNT(CASE WHEN perm_role.name IN (?, ?) THEN 1 ELSE NULL END) IsHelpDeskAllowed --('System Administrator', 'Mobile Helpdesk User')
	, COUNT(CASE WHEN perm_role.name IN (?, ?, ?, ?, ?, ?) THEN 1 ELSE NULL END) IsEditingTagsAllowed --('Audit Administrator', 'Audit Configurator', 'System Administrator', 'Helpdesk Administrator', 'Helpdesk Configurator')
	, COUNT(CASE WHEN perm_role.name IN (?, ?, ?, ?) THEN 1 ELSE NULL END) IsAddingEditingSchedulesAllowed --('Audit Administrator', 'Audit Configurator', 'System Administrator')
	, COUNT(CASE WHEN perm_role.name IN (?) THEN 1 ELSE NULL END) IsUserProofOfPresence --('Mobile Proof of Presence User')
	, COUNT(CASE WHEN perm_role.name IN (?) THEN 1 ELSE NULL END) IsAdhocAllowed --('Mobile Ad-Hoc Auditor')
	, COUNT(CASE WHEN perm_role.name IN (?, ?, ?, ?, ?) THEN 1 ELSE NULL END) IsLocationEditAllowed --('Audit Administrator', 'Audit Configurator', 'Helpdesk Administrator', 'Helpdesk Configurator')
	, COUNT(CASE WHEN perm_role.name IN ('Helpdesk Access All Jobs') THEN 1 ELSE NULL END) IsHeldpeskAccessAllJobs
	, COUNT(CASE WHEN perm_role.name IN ('Helpdesk Mobile Key User') THEN 1 ELSE NULL END) IsHelpdeskKeyUser
FROM systemuser
INNER JOIN inno_usermobiledevice ON systemuser.LocalId = inno_usermobiledevice.inno_usermobiledevicelookup
INNER JOIN inno_mobiledevice ON inno_usermobiledevice.inno_mobiledeviceuserlookup = inno_mobiledevice.LocalId

-- permissions for features witin app
INNER JOIN systemuserroles AS perm_userroles ON perm_userroles.systemuserid == systemuser.systemuserid
INNER JOIN role AS perm_role ON perm_role.roleid = perm_userroles.roleid

-- is allowed to login at all
INNER JOIN systemuserroles ON systemuserroles.systemuserid == systemuser.systemuserid
INNER JOIN role ON role.roleid = systemuserroles.roleid

WHERE 
inno_mobiledevice.inno_mobiledevicenumber = ? -- DeviceId e.g. 'A83C122A932BE8239EC9691B4B2C6E9ED8B22E1F'
AND inno_mobiledevice.inno_status = ? --341380001 == cMobiledevice.eStatusEnumerator.LICENSED
AND inno_usermobiledevice.statecode = ? --0 == cMobiledevice.eStatecodeEnumerator.ACTIVE
AND systemuser.isdisabled = 0
AND role.name IN (?, ?, ?, ?) --('System Administrator', 'Mobile Audit User', 'Mobile Helpdesk User', 'Mobile Proof of Presence User')

GROUP BY 
	systemuser.fullname
	, systemuser.inno_mobilepassword
	, systemuser.systemuserid
	, systemuser.rowid