-- Count of all outstanding audits, across all teams that the user has access to

SELECT  

COUNT(DISTINCT(inno_auditlocationschedule.rowid))

FROM 
inno_auditlocationschedule 
INNER JOIN inno_location LOC ON LOC.inno_locationid = inno_auditlocationschedule.inno_auditlocationschedule_locationid
INNER JOIN inno_location ROOT ON LOC.inno_internalpath LIKE ROOT.inno_internalpath || '%'
INNER JOIN inno_userlocation ON ROOT.LocalId = inno_userlocation.inno_userlocation_locationid


WHERE 

-- ROOT locations of all teams for user
inno_userlocation.inno_userlocation_userid = ?
AND inno_userlocation.statecode = ?
AND inno_userlocation.ownerid IN (
        -- sub query all teams that the user has access to
        SELECT ROOT_T.teamid 
        FROM team ROOT_T 
        INNER JOIN teammembership ROOT_TM ON ROOT_T.teamid = ROOT_TM.teamid
        WHERE ROOT_T.inno_teamtype IN (?, ?, ?) -- Servicetrac, ServicetracAudit, ServicetracAudit+Helpdesk
        AND ROOT_TM.systemuserid = ?
    )
--AND ROOT.statecode = 0

-- All child locations of ROOTs 
AND LOC.statecode = ?

-- All the audit location schedules ALS
AND inno_auditlocationschedule.statecode = ?
AND inno_auditlocationschedule.ownerid IN (
        -- sub query all teams that the user has access to
        SELECT ALS_T.teamid 
        FROM team ALS_T 
        INNER JOIN teammembership ALS_TM ON ALS_T.teamid = ALS_TM.teamid
        WHERE ALS_T.inno_teamtype IN (?, ?, ?) -- Servicetrac, ServicetracAudit, ServicetracAudit+Helpdesk
        AND ALS_TM.systemuserid = ?
    
)
AND inno_auditlocationschedule.inno_nextauditdate > ?
AND inno_auditlocationschedule.inno_nextauditdate < ?

