-- query_team_filter_count_incidents.sql = All Incidents for user and their teams, just the data needed for display nothing extra
SELECT

team.teamid AS TEAM_ID
,COUNT(DISTINCT(incident.incidentid)) AS COUNT_OF_TASKS

FROM incident
INNER JOIN inno_location ON inno_location.inno_locationid = incident.inno_location

INNER JOIN (SELECT inno_internalpath || '%' AS ROOT_inno_internalpath
FROM inno_location
INNER JOIN inno_userlocation ON inno_locationid = inno_userlocation_locationid
WHERE inno_userlocation.inno_userlocation_userid = ? -- UserId
AND inno_userlocation.statecode = ? -- Active == 0
) AS ROOTS ON inno_location.inno_internalpath LIKE ROOT_inno_internalpath

LEFT JOIN inno_status ON inno_status.inno_statusid = incident.inno_statusid
LEFT JOIN team ON team.teamid = incident.inno_incident_assignedteamid
LEFT JOIN teammembership ON team.teamid = teammembership.teamid
LEFT JOIN inno_servicelevel ON inno_servicelevelid = incident.inno_servicelevel

WHERE

    (inno_status.LocalId IS NULL OR (
    	inno_status.inno_statusallowedonmobile <> 0
    	AND inno_status.inno_mappedstatusname NOT IN (?, ?, ?) --(341380010, 341380011)  -- (inno_status_inno_mappedstatusname_enum.ProblemSolved, inno_status_inno_mappedstatusname_enum.Canceled)
    	)
	)
AND (incident.inno_assignedto = ? -- UserId
    OR
        ((incident.inno_assignedto = ? -- Guid.Empty
         OR incident.inno_assignedto IS NULL)
        AND team.inno_teamtype IN  (?, ?) -- (341380002, 341380003) ServicetracHelpdesk, ServicetracAuditHelpdesk
        AND teammembership.systemuserid = ? -- UserId
        )
    )
AND (incident.prioritycode = ? OR incident.followupby < datetime(?) OR incident.followupby BETWEEN datetime(?) AND datetime(?))

GROUP BY team.teamid