SELECT DISTINCT 

inno_auditlocationschedule.rowid _id
,inno_questionset.inno_name AS "inno_questionset_inno_name"
,inno_auditlocationschedule.inno_auditlocationscheduleid
,inno_auditlocationschedule.inno_name
,inno_auditlocationschedule.inno_nextauditdate
, COUNT(inno_questionsetresult.inno_questionsetresultid) AS "HasQuestionResults"

FROM inno_auditlocationschedule
INNER JOIN inno_questionset ON inno_questionset.inno_questionsetid = inno_locationschedule_questionsetid
INNER JOIN teammembership ON team.teamid = inno_auditlocationschedule.ownerid 
INNER JOIN team ON team.teamid = teammembership.teamid
LEFT JOIN inno_repeatpattern ON inno_repeatpattern.inno_repeatpatternid = inno_auditlocationschedule.inno_warningrepeatpatternid
LEFT JOIN inno_questionsetresult ON inno_questionsetresult.inno_auditlocationschedule = inno_auditlocationschedule.inno_auditlocationscheduleid 
	AND inno_questionsetresult.inno_questionsetresult_auditsessionid = ?

WHERE inno_teamtype IN (?, ?)
AND systemuserid = ?
AND inno_auditlocationschedule.owningteam = ?
AND inno_auditlocationschedule_locationid = ?
AND inno_nextauditdate > datetime(?)

-- nowDateTime > Calculator.CalulateNextWarningDate(inno_warningfrequency, inno_warninginterval, inno_nextauditdate)

--inno_repeatpattern repp = (from r in rpList where r.inno_repeatpatternid == auditls.inno_warningrepeatpatternid select r).FirstOrDefault();
--DateTime warningDate = Calculator.NewCalulateNextWarningDate(DateTimeUtil.DateTimeAsUTC(auditls.inno_nextauditdate), now, repp);
 
AND datetime(?) > CASE 
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
    WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
    ELSE datetime(?)
    END

GROUP BY 
inno_auditlocationschedule.rowid
,inno_questionset.inno_name
,inno_auditlocationschedule.inno_auditlocationscheduleid
,inno_auditlocationschedule.inno_name
,inno_auditlocationschedule.inno_nextauditdate

ORDER BY inno_nextauditdate ASC