SELECT DISTINCT [kr].[inno_hooknumber],
                                [kr].[inno_imageurl],
                                [kr].[inno_keycaseid],
                                [kr].[inno_keyringid],
                                [kr].[inno_lastauditdate],
                                [kr].[inno_name],
                                [kr].[inno_sealbroken],
                                [kr].[inno_sealid],
                                [kr].[inno_sealidprevious],
                                [kr].[statecode],
                                [kr].[Localid],
                                [kr].[inno_lastcomment],
                [kc].[inno_name] AS [KeyCaseName],
                [k].[cnt]        AS [NumberOfKeys]
FROM   [inno_keyring] [kr]
       INNER JOIN [inno_keyringlocation] [kl]
               ON [kr].[inno_keyringid] = [kl].[inno_keyringid]
       INNER JOIN [inno_location] [l]
               ON [l].[localid] = [kl].[inno_locationid]
       INNER JOIN [inno_keycase] [kc]
               ON [kc].[inno_keycaseid] = [kr].[inno_keycaseid]
       INNER JOIN [inno_keyringusage] [u]
               ON [u].inno_keyringid = [kr].inno_keyringid
               AND ([u].inno_plannedjobid = ? OR [u].inno_reactivejobid = ?)
       LEFT JOIN (SELECT [k].[inno_keyringid],
                         Count (1) [Cnt]
                  FROM   [inno_key] [k]
                  WHERE  [k].[statecode] = 0
                  GROUP  BY [k].[inno_keyringid]) AS k
              ON [k].[inno_keyringid] = [kr].[localid]
WHERE  [kr].[statecode] = 0
       AND [kr].inno_sealbroken = 1
       AND [kc].[statecode] = 0
       AND ([u].inno_plannedjobid = ? OR [u].inno_reactivejobid = ?)
UNION
SELECT 0                                      AS [inno_hooknumber],
       NULL                                   AS [inno_imageurl],
       '00000000-0000-0000-0000-000000000000' AS [inno_keycaseid],
       '00000000-0000-0000-0000-000000000000' AS [inno_keyringid],
       Datetime('now')                        AS [inno_lastauditdate],
       'No Keyrings Required'                 AS [inno_name],
       0                                      AS [inno_sealbroken],
       ''                                     AS [inno_sealid],
       ''                                     AS [inno_sealidprevious],
       0                                      AS [statecode],
       '00000000-0000-0000-0000-000000000000' AS [Localid],
       ''                                     AS [inno_lastcomment],
       ''                                     AS [KeyCaseName],
       0                                      AS [NumberOfKeys]
ORDER  BY [inno_keycaseid] ASC,[inno_hooknumber] ASC