-- Audit Location Schedules - query_site_tree_audit_schedules_by_location.sql -- count ALSs for specified location(s)
SELECT
inno_auditlocationschedule_locationid
, COUNT(DISTINCT(inno_auditlocationschedule.inno_auditlocationscheduleid)) AS COUNT_OF_ALS
-- AG: Add Warning Date Alias Column on the fly to Query Against (instead of inno_nextauditdate)
, CASE
           WHEN inno_repeatpatternstyle = '341380005' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
           WHEN inno_repeatpatternstyle = '341380006' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
           WHEN inno_repeatpatternstyle = '341380007' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
           WHEN inno_repeatpatternstyle = '341380008' THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
           WHEN inno_repeatpatternstyle = '341380009' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
           WHEN inno_repeatpatternstyle = '3413800010' THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
           ELSE inno_nextauditdate
           END AS WarningDate




























FROM inno_auditlocationschedule
INNER JOIN inno_questionset ON inno_questionset.inno_questionsetid = inno_locationschedule_questionsetid
INNER JOIN team ON team.teamid = inno_auditlocationschedule.ownerid
INNER JOIN teammembership ON team.teamid = teammembership.teamid
INNER JOIN inno_location ON inno_location.inno_locationid = inno_auditlocationschedule_locationid
LEFT JOIN inno_repeatpattern ON inno_repeatpattern.inno_repeatpatternid = inno_auditlocationschedule.inno_warningrepeatpatternid

--
LEFT JOIN inno_sampleauditperiod samp ON inno_auditlocationschedule.inno_sampleauditperiodid =
 samp.localid
--


WHERE team.inno_teamtype IN (?, ?)
AND teammembership.systemuserid = ?
AND inno_auditlocationschedule.ownerid = ?
--AND (inno_nextauditdate < datetime(?) OR inno_nextauditdate BETWEEN datetime(?) AND datetime(?))
AND ((inno_nextauditdate < datetime(?) OR inno_nextauditdate BETWEEN datetime(?) AND datetime(?)
OR WarningDate < datetime(?) OR WarningDate BETWEEN datetime(?) AND datetime(?)
AND inno_nextauditdate > '1969-01-01') OR inno_nextauditdate IS NULL)
AND inno_auditlocationschedule.statecode = ? -- ACTIVE == 0
AND CASE
    -- Is Overdue
    WHEN inno_nextauditdate < datetime(?) THEN 'o'
    -- Is Due
    --
    WHEN samp.inno_startdate NOT NULL AND samp.inno_startdate < CURRENT_TIMESTAMP THEN 'd'
    --
    WHEN datetime(?) > CASE
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' minutes')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' hours')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' days')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || (inno_repeatpatternvalue1 * 7) || ' days')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' months')
        WHEN inno_repeatpatternstyle = ? THEN datetime(inno_nextauditdate, '-' || inno_repeatpatternvalue1 || ' years')
        ELSE datetime(?)
        END THEN 'd'
    -- Is not due
    ELSE 'n'
    END IN (?, ?, ?)

--AND inno_auditlocationschedule_locationid = ?
[XX-LOCATION-XX]


GROUP BY
inno_auditlocationschedule_locationid






ORDER BY inno_auditlocationschedule_locationid ASC
